Index: protocols/twitter/Makefile
===================================================================
--- protocols/twitter/Makefile	(revision 38ff846b14f1d1f80983a0818b9bcf60581a2a34)
+++ protocols/twitter/Makefile	(revision 8b8def5854857248f66b6a2580ce2e5a8f5597c8)
@@ -8,4 +8,7 @@
 
 -include ../../Makefile.settings
+ifdef SRCDIR
+SRCDIR := $(SRCDIR)protocols/twitter/
+endif
 
 # [SH] Program variables
@@ -33,5 +36,5 @@
 $(objects): ../../Makefile.settings Makefile
 
-$(objects): %.o: %.c
+$(objects): %.o: $(SRCDIR)%.c
 	@echo '*' Compiling $<
 	@$(CC) -c $(CFLAGS) $< -o $@
Index: protocols/twitter/twitter_lib.c
===================================================================
--- protocols/twitter/twitter_lib.c	(revision 38ff846b14f1d1f80983a0818b9bcf60581a2a34)
+++ protocols/twitter/twitter_lib.c	(revision 8b8def5854857248f66b6a2580ce2e5a8f5597c8)
@@ -105,5 +105,5 @@
 
 	// Check if the buddy is allready in the buddy list.
-	if (!imcb_find_buddy( ic, name ))
+	if (!bee_user_by_handle( ic->bee, ic, name ))
 	{
 		char *mode = set_getstr(&ic->acc->set, "mode");
Index: protocols/yahoo/Makefile
===================================================================
--- protocols/yahoo/Makefile	(revision 38ff846b14f1d1f80983a0818b9bcf60581a2a34)
+++ protocols/yahoo/Makefile	(revision 8b8def5854857248f66b6a2580ce2e5a8f5597c8)
@@ -8,4 +8,7 @@
 
 -include ../../Makefile.settings
+ifdef SRCDIR
+SRCDIR := $(SRCDIR)protocols/yahoo/
+endif
 
 # [SH] Program variables
@@ -33,5 +36,5 @@
 $(objects): ../../Makefile.settings Makefile
 
-$(objects): %.o: %.c
+$(objects): %.o: $(SRCDIR)%.c
 	@echo '*' Compiling $<
 	@$(CC) -c $(CFLAGS) $< -o $@
Index: protocols/yahoo/yahoo.c
===================================================================
--- protocols/yahoo/yahoo.c	(revision 38ff846b14f1d1f80983a0818b9bcf60581a2a34)
+++ protocols/yahoo/yahoo.c	(revision 8b8def5854857248f66b6a2580ce2e5a8f5597c8)
@@ -158,5 +158,5 @@
 	
 	while( ic->groupchats )
-		imcb_chat_free( ic->groupchats );
+		imcb_chat_free( ic->groupchats->data );
 	
 	for( l = yd->buddygroups; l; l = l->next )
@@ -613,8 +613,6 @@
 	imcb_buddy_status( ic, who, flags, state_string, msg );
 	
-	/* Not implemented yet...
 	if( stat == YAHOO_STATUS_IDLE )
-		imcb_buddy_times( ic, who, 0, away );
-	*/
+		imcb_buddy_times( ic, who, 0, idle );
 }
 
@@ -686,5 +684,5 @@
 		
 		inp->d = d;
-		d->tag = inp->h = b_input_add( fd, GAIM_INPUT_READ, (b_event_handler) byahoo_read_ready_callback, (gpointer) d );
+		d->tag = inp->h = b_input_add( fd, B_EV_IO_READ, (b_event_handler) byahoo_read_ready_callback, (gpointer) d );
 	}
 	else if( cond == YAHOO_INPUT_WRITE )
@@ -697,5 +695,5 @@
 		
 		inp->d = d;
-		d->tag = inp->h = b_input_add( fd, GAIM_INPUT_WRITE, (b_event_handler) byahoo_write_ready_callback, (gpointer) d );
+		d->tag = inp->h = b_input_add( fd, B_EV_IO_WRITE, (b_event_handler) byahoo_write_ready_callback, (gpointer) d );
 	}
 	else
@@ -796,8 +794,12 @@
 	struct byahoo_conf_invitation *inv = data;
 	struct groupchat *b;
-	
-	for( b = inv->ic->groupchats; b; b = b->next )
+	GSList *l;
+	
+	for( l = inv->ic->groupchats; l; l = l->next )
+	{
+		b = l->data;
 		if( b == inv->c )
 			break;
+	}
 	
 	if( b != NULL )
@@ -865,7 +867,5 @@
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
-	struct groupchat *c;
-	
-	for( c = ic->groupchats; c && strcmp( c->title, room ) != 0; c = c->next );
+	struct groupchat *c = bee_chat_by_title( ic->bee, ic, room );
 	
 	if( c )
@@ -877,7 +877,5 @@
 {
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
-	struct groupchat *c;
-	
-	for( c = ic->groupchats; c && strcmp( c->title, room ) != 0; c = c->next );
+	struct groupchat *c = bee_chat_by_title( ic->bee, ic, room );
 	
 	if( c )
@@ -889,7 +887,5 @@
 	struct im_connection *ic = byahoo_get_ic_by_id( id );
 	char *m = byahoo_strip( msg );
-	struct groupchat *c;
-	
-	for( c = ic->groupchats; c && strcmp( c->title, room ) != 0; c = c->next );
+	struct groupchat *c = bee_chat_by_title( ic->bee, ic, room );
 	
 	if( c )
